<!doctype html>
<html lang="en">
<head>
    <title>Easy Bash Programmable Tab Completion</title>
    <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <meta http-equiv="Cache-Control" content="no-cache, no-store, must-revalidate"/>
  <link rel="shortcut icon" href="/assets/img/logo.png" type="image/png">
  <meta http-equiv="Pragma" content="no-cache"/>
  <meta http-equiv="Expires" content="0"/>
  <!-- link rel="shortcut icon" href="/assets/img/logo.png" type="image/png"-->
  <link rel="stylesheet" href="/assets/styles.css">
</head>
<body>
<header class=nav-bar>
  <nav>
    <div class=sidebar-button></div>
    <!--div id=bwtoggle></div-->
    <a class="homelink spy" href="/">r<span class=hideable>wx.gg</span></a>
    <div class="nav-right">
      <!-- div id=search-box></div -->
      <ul class=nav-links>
        <li class=nav-item><a class=nav-link href="/boost/">Boosts</a></li>
        <!--
        <li class=nav-item><a class=nav-link href="/how/">HowTos</a></li>
        <li class=nav-item><a class=nav-link href="/contrib/">Contribute</a></li>
        -->
        <li class=nav-item><a class="nav-link" href="https://gitlab.com/rwx.gg/README">GitLab</a></li>
        <li class=nav-item><a class="nav-link" href="https://www.youtube.com/rwxrob">YouTube</a></li>
        <li class=nav-item><a class="nav-link" href="https://discord.gg/9wydZXY">Discord</a></li>
        <li class=nav-item><a class="nav-link" href="https://twitch.tv/rwxrob">Twitch</a></li>
      </ul>
    </div>
  </nav>
</header>
<main id=top>
<div class=container>  <h1 id=title class=duck><a href="https://duckduckgo.com/lite?kae=t&q=Easy Bash Programmable Tab Completion">Easy Bash Programmable Tab Completion</a></h1>
  <h2 id=subtitle>A Tab is Worth a Thousand Words</h2>
  <p>Bash tab completion is perhaps one of the most overly and unnecessarily complicated topics in all of Linux. The best documentation on it remains the Bash man page itself, but even that is complex and gives almost <em>zero</em> attention to the humble <code>complete -C foo foo</code> approach even though implementing tab completion using <code>-C</code> instead of <code>-F</code> and others means that the code that prints the possible completions is <em>also</em> the code that executes the completed command line. Bundling completion <em>with</em> the command is simple, concise, and more sustainable. There isn’t an additional script to maintain and install (typically in <code>/etc/bash_completion.d</code>). Users just add the <code>complete</code> to their Bash configuration and works. Those making software packages can still install a separate completion script, but it becomes a single line instead of an overly complicated Bash function. Moreover, your code — with encapsulated, detectable completion mode — will be ready to integrate into any number of other shells that support it besides Bash. When you consider these advantages its rather surprising everyone doesn’t use this method probably because most just don’t know about. Now you do.</p>
  <p>Here are some simple examples written in Bash to get the idea. The <code>week</code> script just prints out the first argument, which can be any days of the week. (Normally this would be simple enough to just implement with <code>complete -W</code> but this is to illustrate how it works.)</p>
  <h2 id="setup-a-test-script">Setup a Test Script</h2>
  <p>First you’ll need to find a place to create a simple Bash script, preferably not in your <code>PATH</code>.</p>
  <pre class="sh"><code>cd /tmp
  touch week
  chmod u+x week</code></pre>
  <p>Then go ahead and execute the <code>complete</code> command in the currently running shell. Note that we are using the local directory path just for our test.</p>
  <pre class="sh"><code>complete -C ./week ./week</code></pre>
  <p>You can already test this by running <code>./week</code> and tapping <code>Tab</code> a couple times to see that it does nothing, having taken over the default Bash tab completion that uses files and directories.</p>
</main>
<footer>
  <p><a href="/copyright/" id=copyright>© 2020 Rob Muhlestein. Licensed under Creative Commons Attribution-ShareAlike.</a><br/>Does something seem to have changed? <a href="/changes/">Check the change log</a>.
  <br>See something wrong? <a class="nodecor" href="https://gitlab.com/rwx.gg/README/-/issues">Open a ticket</a>.
  </p>
</footer>
<script src="/assets/main.js"></script>
</body>
</html>